;; Conversions between Unicode and LaTeX ascii code

;; (C) 2012 Francois Poulain, (C) 2021 Joris van der Hoeven
;;
;; This software falls under the GNU general public license version 3 or later.
;; It comes WITHOUT ANY WARRANTY WHATSOEVER. For details, see the file LICENSE
;; in the root directory or <http://www.gnu.org/licenses/gpl-3.0.html>.
;;
;; Inspired from utf8enc.dfu

("#7C" "{\\textbar}")
("#A1" "{\\textexclamdown}")
("#A2" "{\\textcent}")
("#A3" "{\\textsterling}")
("#A4" "{\\textcurrency}")
("#A5" "{\\textyen}")
("#A6" "{\\textbrokenbar}")
("#A7" "{\\textsection}")
("#A8" "{\\textasciidieresis}")
("#A9" "{\\textcopyright}")
("#AA" "{\\textordfeminine}")
("#AB" "{\\guillemotleft}")
("#AC" "{\\textlnot}")
("#AE" "{\\textregistered}")
("#AF" "{\\textasciimacron}")
("#B0" "{\\textdegree}")
("#B1" "{\\textpm}")
("#B2" "{\\texttwosuperior}")
("#B3" "{\\textthreesuperior}")
("#B4" "{\\textasciiacute}")
("#B5" "{\\textmu}") ; micro sign
("#B6" "{\\P}")
("#B7" "{\\textperiodcentered}")
("#B8" "\\c{}")
("#B9" "{\\textonesuperior}")
("#BA" "{\\textordmasculine}")
("#BB" "{\\guillemotright}")
("#BC" "{\\textonequarter}")
("#BD" "{\\textonehalf}")
("#BE" "{\\textthreequarters}")
("#BF" "{\\textquestiondown}")
("#C0" "{\\`A}")
("#C1" "{\\'A}")
("#C2" "{\\^A}")
("#C3" "{\\~A}")
("#C4" "{\\\"A}")
("#C5" "{\\r A}")
("#C6" "{\\AE}")
("#C7" "{\\c C}")
("#C8" "{\\`E}")
("#C9" "{\\'E}")
("#CA" "{\\^E}")
("#CB" "{\\\"E}")
("#CC" "{\\`I}")
("#CD" "{\\'I}")
("#CE" "{\\^I}")
("#CF" "{\\\"I}")
("#D0" "{\\DH}")
("#D1" "{\\~N}")
("#D2" "{\\`O}")
("#D3" "{\\'O}")
("#D4" "{\\^O}")
("#D5" "{\\~O}")
("#D6" "{\\\"O}")
("#D7" "{\\texttimes}")
("#D8" "{\\O}")
("#D9" "{\\`U}")
("#DA" "{\\'U}")
("#DB" "{\\^U}")
("#DC" "{\\\"U}")
("#DD" "{\\'Y}")
("#DE" "{\\TH}")
("#DF" "{\\ss}")
("#E0" "{\\`a}")
("#E1" "{\\'a}")
("#E2" "{\\^a}")
("#E3" "{\\~a}")
("#E4" "{\\\"a}")
("#E5" "{\\r a}")
("#E6" "{\\ae}")
("#E7" "{\\c c}")
("#E8" "{\\`e}")
("#E9" "{\\'e}")
("#EA" "{\\^e}")
("#EB" "{\\\"e}")
("#EC" "{\\`\\i}")
("#ED" "{\\'\\i}")
("#EE" "{\\^\\i}")
("#EF" "{\\\"\\i}")
("#F0" "{\\dh}")
("#F1" "{\\~n}")
("#F2" "{\\`o}")
("#F3" "{\\'o}")
("#F4" "{\\^o}")
("#F5" "{\\~o}")
("#F6" "{\\\"o}")
("#F7" "{\\textdiv}")
("#F8" "{\\o}")
("#F9" "{\\`u}")
("#FA" "{\\'u}")
("#FB" "{\\^u}")
("#FC" "{\\\"u}")
("#FD" "{\\'y}")
("#FE" "{\\th}")
("#FF" "{\\\"y}")
("#102" "{\\u A}")
("#103" "{\\u a}")
("#104" "{\\k A}")
("#105" "{\\k a}")
("#106" "{\\'C}")
("#107" "{\\'c}")
("#10C" "{\\v C}")
("#10D" "{\\v c}")
("#10E" "{\\v D}")
("#10F" "{\\v d}")
("#110" "{\\DJ}")
("#111" "{\\dj}")
("#118" "{\\k E}")
("#119" "{\\k e}")
("#11A" "{\\v E}")
("#11B" "{\\v e}")
("#11E" "{\\u G}")
("#11F" "{\\u g}")
("#130" "{\\.I}")
("#131" "{\\i}")
("#132" "{\\IJ}")
("#133" "{\\ij}")
("#139" "{\\'L}")
("#13A" "{\\'l}")
("#13D" "{\\v L}")
("#13E" "{\\v l}")
("#141" "{\\L}")
("#142" "{\\l}")
("#143" "{\\'N}")
("#144" "{\\'n}")
("#147" "{\\v N}")
("#148" "{\\v n}")
("#14A" "{\\NG}")
("#14B" "{\\ng}")
("#14C" "{\\=O}")
("#14D" "{\\=o}")
("#14E" "{\\u O}")
("#14F" "{\\u o}")
("#150" "{\\H O}")
("#151" "{\\H o}")
("#152" "{\\OE}")
("#153" "{\\oe}")
("#154" "{\\'R}")
("#155" "{\\'r}")
("#158" "{\\v R}")
("#159" "{\\v r}")
("#15A" "{\\'S}")
("#15B" "{\\'s}")
("#15E" "{\\c S}")
("#15F" "{\\c s}")
("#160" "{\\v S}")
("#161" "{\\v s}")
("#162" "{\\c T}")
("#163" "{\\c t}")
("#164" "{\\v T}")
("#165" "{\\v t}")
("#16E" "{\\r U}")
("#16F" "{\\r u}")
("#170" "{\\H U}")
("#171" "{\\H u}")
("#178" "{\\\"Y}")
("#179" "{\\'Z}")
("#17A" "{\\'z}")
("#17B" "{\\.Z}")
("#17C" "{\\.z}")
("#17D" "{\\v Z}")
("#17E" "{\\v z}")
("#192" "{\\textflorin}")
("#2C6" "{\\textasciicircum}")
("#2C7" "{\\textasciicaron}")
("#2DC" "{\\textasciitilde}")
("#2D8" "{\\textasciibreve}")
("#2DD" "{\\textacutedbl}")
("#311" "{\\textroundcap}")
("#3BC" "{\\textmu}")
("#400" "{\\`\\CYRE}")
("#401" "{\\CYRYO}")
("#402" "{\\CYRDJE}")
("#403" "{\\`\\CYRG}")
("#404" "{\\CYRIE}")
("#405" "{\\CYRDZE}")
("#406" "{\\CYRII}")
("#407" "{\\CYRYI}")
("#408" "{\\CYRJE}")
("#409" "{\\CYRLJE}")
("#40A" "{\\CYRNJE}")
("#40B" "{\\CYRTSHE}")
("#40C" "{\\`\\CYRK}")
("#40D" "{\\`\\CYRI}")
("#40E" "{\\CYRUSHRT}")
("#40F" "{\\CYRDZHE}")
("#410" "{\\CYRA}")
("#411" "{\\CYRB}")
("#412" "{\\CYRV}")
("#413" "{\\CYRG}")
("#414" "{\\CYRD}")
("#415" "{\\CYRE}")
("#416" "{\\CYRZH}")
("#417" "{\\CYRZ}")
("#418" "{\\CYRI}")
("#419" "{\\CYRISHRT}")
("#41A" "{\\CYRK}")
("#41B" "{\\CYRL}")
("#41C" "{\\CYRM}")
("#41D" "{\\CYRN}")
("#41E" "{\\CYRO}")
("#41F" "{\\CYRP}")
("#420" "{\\CYRR}")
("#421" "{\\CYRS}")
("#422" "{\\CYRT}")
("#423" "{\\CYRU}")
("#424" "{\\CYRF}")
("#425" "{\\CYRH}")
("#426" "{\\CYRC}")
("#427" "{\\CYRCH}")
("#428" "{\\CYRSH}")
("#429" "{\\CYRSHCH}")
("#42A" "{\\CYRHRDSN}")
("#42B" "{\\CYRERY}")
("#42C" "{\\CYRSFTSN}")
("#42D" "{\\CYREREV}")
("#42E" "{\\CYRYU}")
("#42F" "{\\CYRYA}")
("#430" "{\\cyra}")
("#431" "{\\cyrb}")
("#432" "{\\cyrv}")
("#433" "{\\cyrg}")
("#434" "{\\cyrd}")
("#435" "{\\cyre}")
("#436" "{\\cyrzh}")
("#437" "{\\cyrz}")
("#438" "{\\cyri}")
("#439" "{\\cyrishrt}")
("#43A" "{\\cyrk}")
("#43B" "{\\cyrl}")
("#43C" "{\\cyrm}")
("#43D" "{\\cyrn}")
("#43E" "{\\cyro}")
("#43F" "{\\cyrp}")
("#440" "{\\cyrr}")
("#441" "{\\cyrs}")
("#442" "{\\cyrt}")
("#443" "{\\cyru}")
("#444" "{\\cyrf}")
("#445" "{\\cyrh}")
("#446" "{\\cyrc}")
("#447" "{\\cyrch}")
("#448" "{\\cyrsh}")
("#449" "{\\cyrshch}")
("#44A" "{\\cyrhrdsn}")
("#44B" "{\\cyrery}")
("#44C" "{\\cyrsftsn}")
("#44D" "{\\cyrerev}")
("#44E" "{\\cyryu}")
("#44F" "{\\cyrya}")
("#450" "{\\`\\cyre}")
("#451" "{\\cyryo}")
("#452" "{\\cyrdje}")
("#453" "{\\`\\cyrg}")
("#454" "{\\cyrie}")
("#455" "{\\cyrdze}")
("#456" "{\\cyrii}")
("#457" "{\\cyryi}")
("#458" "{\\cyrje}")
("#459" "{\\cyrlje}")
("#45A" "{\\cyrnje}")
("#45B" "{\\cyrtshe}")
("#45C" "{\\`\\cyrk}")
("#45D" "{\\`\\cyri}")
("#45E" "{\\cyrushrt}")
("#45F" "{\\cyrdzhe}")
("#462" "{\\CYRYAT}")
("#463" "{\\cyryat}")
("#46A" "{\\CYRBYUS}")
("#46B" "{\\cyrbyus}")
("#472" "{\\CYRFITA}")
("#473" "{\\cyrfita}")
("#474" "{\\CYRIZH}")
("#475" "{\\cyrizh}")
("#476" "{\\C\\CYRIZH}")
("#477" "{\\C\\cyrizh}")
("#48C" "{\\CYRSEMISFTSN}")
("#48D" "{\\cyrsemisftsn}")
("#48E" "{\\CYRRTICK}")
("#48F" "{\\cyrrtick}")
("#490" "{\\CYRGUP}")
("#491" "{\\cyrgup}")
("#492" "{\\CYRGHCRS}")
("#493" "{\\cyrghcrs}")
("#494" "{\\CYRGHK}")
("#495" "{\\cyrghk}")
("#496" "{\\CYRZHDSC}")
("#497" "{\\cyrzhdsc}")
("#498" "{\\CYRZDSC}")
("#499" "{\\cyrzdsc}")
("#49A" "{\\CYRKDSC}")
("#49B" "{\\cyrkdsc}")
("#49C" "{\\CYRKVCRS}")
("#49D" "{\\cyrkvcrs}")
("#49E" "{\\CYRKHCRS}")
("#49F" "{\\cyrkhcrs}")
("#4A0" "{\\CYRKBEAK}")
("#4A1" "{\\cyrkbeak}")
("#4A2" "{\\CYRNDSC}")
("#4A3" "{\\cyrndsc}")
("#4A4" "{\\CYRNG}")
("#4A5" "{\\cyrng}")
("#4A6" "{\\CYRPHK}")
("#4A7" "{\\cyrphk}")
("#4A8" "{\\CYRABHHA}")
("#4A9" "{\\cyrabhha}")
("#4AA" "{\\CYRSDSC}")
("#4AB" "{\\cyrsdsc}")
("#4AC" "{\\CYRTDSC}")
("#4AD" "{\\cyrtdsc}")
("#4AE" "{\\CYRY}")
("#4AF" "{\\cyry}")
("#4B0" "{\\CYRYHCRS}")
("#4B1" "{\\cyryhcrs}")
("#4B2" "{\\CYRHDSC}")
("#4B3" "{\\cyrhdsc}")
("#4B4" "{\\CYRTETSE}")
("#4B5" "{\\cyrtetse}")
("#4B6" "{\\CYRCHRDSC}")
("#4B7" "{\\cyrchrdsc}")
("#4B8" "{\\CYRCHVCRS}")
("#4B9" "{\\cyrchvcrs}")
("#4BA" "{\\CYRSHHA}")
("#4BB" "{\\cyrshha}")
("#4BC" "{\\CYRABHCH}")
("#4BD" "{\\cyrabhch}")
("#4BE" "{\\CYRABHCHDSC}")
("#4BF" "{\\cyrabhchdsc}")
("#4C0" "{\\CYRpalochka}")
("#4C1" "{\\U\\CYRZH}")
("#4C2" "{\\U\\cyrzh}")
("#4C3" "{\\CYRKHK}")
("#4C4" "{\\cyrkhk}")
("#4C5" "{\\CYRLDSC}")
("#4C6" "{\\cyrldsc}")
("#4C7" "{\\CYRNHK}")
("#4C8" "{\\cyrnhk}")
("#4CB" "{\\CYRCHLDSC}")
("#4CC" "{\\cyrchldsc}")
("#4CD" "{\\CYRMDSC}")
("#4CE" "{\\cyrmdsc}")
("#4D0" "{\\U\\CYRA}")
("#4D1" "{\\U\\cyra}")
("#4D2" "{\\\"\\CYRA}")
("#4D3" "{\\\"\\cyra}")
("#4D4" "{\\CYRAE}")
("#4D5" "{\\cyrae}")
("#4D6" "{\\U\\CYRE}")
("#4D7" "{\\U\\cyre}")
("#4D8" "{\\CYRSCHWA}")
("#4D9" "{\\cyrschwa}")
("#4DA" "{\\\"\\CYRSCHWA}")
("#4DB" "{\\\"\\cyrschwa}")
("#4DC" "{\\\"\\CYRZH}")
("#4DD" "{\\\"\\cyrzh}")
("#4DE" "{\\\"\\CYRZ}")
("#4DF" "{\\\"\\cyrz}")
("#4E0" "{\\CYRABHDZE}")
("#4E1" "{\\cyrabhdze}")
("#4E2" "{\\=\\CYRI}")
("#4E3" "{\\=\\cyri}")
("#4E4" "{\\\"\\CYRI}")
("#4E5" "{\\\"\\cyri}")
("#4E6" "{\\\"\\CYRO}")
("#4E7" "{\\\"\\cyro}")
("#4E8" "{\\CYROTLD}")
("#4E9" "{\\cyrotld}")
("#4EC" "{\\\"\\CYREREV}")
("#4ED" "{\\\"\\cyrerev}")
("#4EE" "{\\=\\CYRU}")
("#4EF" "{\\=\\cyru}")
("#4F0" "{\\\"\\CYRU}")
("#4F1" "{\\\"\\cyru}")
("#4F2" "{\\H\\CYRU}")
("#4F3" "{\\H\\cyru}")
("#4F4" "{\\\"\\CYRCH}")
("#4F5" "{\\\"\\cyrch}")
("#4F6" "{\\CYRGDSC}")
("#4F7" "{\\cyrgdsc}")
("#4F8" "{\\\"\\CYRERY}")
("#4F9" "{\\\"\\cyrery}")
("#4FA" "{\\CYRGDSCHCRS}")
("#4FB" "{\\cyrgdschcrs}")
("#4FC" "{\\CYRHHK}")
("#4FD" "{\\cyrhhk}")
("#4FE" "{\\CYRHHCRS}")
("#4FF" "{\\cyrhhcrs}")
("#E3F" "{\\textbaht}")
("#200C" "{\\textcompwordmark}")
("#2013" "{\\textendash}")
("#2014" "{\\textemdash}")
("#2016" "{\\textbardbl}")
("#201A" "{\\quotesinglbase}")
("#201E" "{\\quotedblbase}")
("#2020" "{\\textdagger}")
("#2021" "{\\textdaggerdbl}")
("#2022" "{\\textbullet}")
("#2026" "{\\textellipsis}")
("#2030" "{\\textperthousand}")
("#2031" "{\\textpertenthousand}")
("#2039" "{\\guilsinglleft}")
("#203A" "{\\guilsinglright}")
("#203B" "{\\textreferencemark}")
("#203D" "{\\textinterrobang}")
("#2044" "{\\textfractionsolidus}")
("#204E" "{\\textasteriskcentered}") ; LOW ASTERISK
("#2052" "{\\textdiscount}")
("#20A1" "{\\textcolonmonetary}")
("#20A4" "{\\textlira}")
("#20A6" "{\\textnaira}")
("#20A9" "{\\textwon}")
("#20AB" "{\\textdong}")
("#20AC" "{\\texteuro}")
("#20B1" "{\\textpeso}")
("#2103" "{\\textcelsius}")
("#2116" "{\\textnumero}")
("#2117" "{\\textcircledP}")
("#211E" "{\\textrecipe}")
("#2120" "{\\textservicemark}")
("#2122" "{\\texttrademark}")
("#2126" "{\\textohm}")
("#2127" "{\\textmho}")
("#212E" "{\\textestimated}")
("#2190" "{\\ensuremath{\\leftarrow}}")
("#2191" "{\\ensuremath{\\uparrow}}")
("#2192" "{\\ensuremath{\\rightarrow}}")
("#2193" "{\\ensuremath{\\downarrow}}")
("#2196" "{\\ensuremath{\\nwarrow}}")
("#2198" "{\\ensuremath{\\searrow}}")
("#21A9" "{\\ensuremath{\\hookleftarrow}}")
("#21DE" "{PageUp }")
("#21DF" "{PageDown }")
("#21E5" "{\\ensuremath{\\rightarrow\\shortmid}}") ;; FIXME: Hack for tab key
("#21E7" "{\\ensuremath{\\Uparrow}}")              ;; FIXME: Hack for shift key
("#21EA" "{CapsLock }")
("#2303" "{Ctrl }")
("#2318" "{Cmd }")
("#2325" "{Alt }")
("#2326" "{Del }")
("#2329" "{\\ensuremath{\\langle}}")
("#232A" "{\\ensuremath{\\rangle}}")
("#232B" "{Bksp }")
("#2422" "{\\ensuremath{\\blank}}")
("#2423" "{\\;\\;}")                           ;; FIXME: hack for \visiblespace
("#238B" "{Esc }")
("#25E6" "{\\ensuremath{\\openbullet}}")
("#25EF" "{\\ensuremath{\\bigcircle}}")
("#266A" "{\\ensuremath{\\musicalnote}}")
("#1D6FC" "{\\ensuremath{\\alpha}}")
("#1D6FD" "{\\ensuremath{\\beta}}")
("#1D6FE" "{\\ensuremath{\\gamma}}")
("#1D6FF" "{\\ensuremath{\\delta}}")
("#1D700" "{\\ensuremath{\\varepsilon}}")
("#1D701" "{\\ensuremath{\\zeta}}")
("#1D702" "{\\ensuremath{\\eta}}")
("#1D703" "{\\ensuremath{\\theta}}")
("#1D704" "{\\ensuremath{\\iota}}")
("#1D705" "{\\ensuremath{\\kappa}}")
("#1D706" "{\\ensuremath{\\lambda}}")
("#1D707" "{\\ensuremath{\\mu}}")
("#1D708" "{\\ensuremath{\\nu}}")
("#1D709" "{\\ensuremath{\\xi}}")
("#1D70A" "{\\ensuremath{\\omicron}}")
("#1D70B" "{\\ensuremath{\\pi}}")
("#1D70C" "{\\ensuremath{\\rho}}")
("#1D70D" "{\\ensuremath{\\varsigma}}")
("#1D70E" "{\\ensuremath{\\sigma}}")
("#1D70F" "{\\ensuremath{\\tau}}")
("#1D710" "{\\ensuremath{\\upsilon}}")
("#1D711" "{\\ensuremath{\\varphi}}")
("#1D712" "{\\ensuremath{\\chi}}")
("#1D713" "{\\ensuremath{\\psi}}")
("#1D714" "{\\ensuremath{\\omega}}")
("#1D715" "{\\ensuremath{\\partial}}")
("#1D716" "{\\ensuremath{\\epsilon}}")
("#1D717" "{\\ensuremath{\\vartheta}}")
("#1D718" "{\\ensuremath{\\varkappa}}")
("#1D719" "{\\ensuremath{\\phi}}")
("#1D71A" "{\\ensuremath{\\varrho}}")
("#1D71B" "{\\ensuremath{\\varpi}}")
