
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : init-prog_javascript.scm
;; DESCRIPTION : prog format for Javascript
;; COPYRIGHT   : (C) 2023  Darcy Shen, Joris van der Hoeven
;;
;; This software falls under the GNU general public license version 3 or later.
;; It comes WITHOUT ANY WARRANTY WHATSOEVER. For details, see the file LICENSE
;; in the root directory or <http://www.gnu.org/licenses/gpl-3.0.html>.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(texmacs-module (data javascript))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Javascript source files
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define-format javascript
  (:name "Javascript source code")
  (:suffix "js"))
  
(define (texmacs->javascript x . opts)
  (texmacs->verbatim x (acons "texmacs->verbatim:encoding" "SourceCode" '())))

(define (javascript->texmacs x . opts)
  (code->texmacs x))

(define (javascript-snippet->texmacs x . opts)
  (code-snippet->texmacs x))

(converter texmacs-tree javascript-document
  (:function texmacs->javascript))

(converter javascript-document texmacs-tree
  (:function javascript->texmacs))
  
(converter texmacs-tree javascript-snippet
  (:function texmacs->javascript))

(converter javascript-snippet texmacs-tree
  (:function javascript-snippet->texmacs))
