
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; MODULE      : r7rs.scm
;; DESCRIPTION : prog format for r7rs
;; COPYRIGHT   : (C) 2022  Darcy Shen, Joris van der Hoeven
;;
;; This software falls under the GNU general public license version 3 or later.
;; It comes WITHOUT ANY WARRANTY WHATSOEVER. For details, see the file LICENSE
;; in the root directory or <http://www.gnu.org/licenses/gpl-3.0.html>.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(texmacs-module (data r7rs))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; r7rs source files
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define-format r7rs
  (:name "R7RS source code")
  (:suffix "scm" ".sld" ".ss"))
  
(define (texmacs->r7rs x . opts)
  (texmacs->verbatim x (acons "texmacs->verbatim:encoding" "SourceCode" '())))

(define (r7rs->texmacs x . opts)
  (code->texmacs x))

(define (r7rs-snippet->texmacs x . opts)
  (code-snippet->texmacs x))

(converter texmacs-tree r7rs-document
  (:function texmacs->r7rs))

(converter r7rs-document texmacs-tree
  (:function r7rs->texmacs))
  
(converter texmacs-tree r7rs-snippet
  (:function texmacs->r7rs))

(converter r7rs-snippet texmacs-tree
  (:function r7rs-snippet->texmacs))
